# Rules shared between Makefile.std and Makefile.sub

vpath %,v RCS

space := $(empty) $(empty)

# Set up search path for library dependencies
# Note: It is important to avoid these vpath directives when compiling
# libraries, because otherwise the directories are searched for the target.
ifneq ($(strip $(LIBS)),)
ifneq ($(strip $(LOCALLIBDIRS)),)
vpath %.a $(subst $(space),:,$(subst -L,,$(LOCALLIBDIRS)))
vpath %.so $(subst $(space),:,$(subst -L,,$(LOCALLIBDIRS)))
endif
vpath %.a $(LIBDIR)
vpath %.so $(SODIR)
ifneq ($(strip $(GLOBALLIBDIRS)),)
vpath %.a $(subst $(space),:,$(subst -L,,$(GLOBALLIBDIRS)))
vpath %.so $(subst $(space),:,$(subst -L,,$(GLOBALLIBDIRS)))
endif
endif

# Special rule: the standard makefiles should always be the most recent
# versions.

FORCE:

%.cc : %.y
		@rm -f $@
		$(YACC) $(YFLAGS) $<
		@chmod 444 y.tab.c
		mv y.tab.c $@

%.c : %.y
		@rm -f $@
		$(YACC) $(YFLAGS) $<
		@chmod 444 y.tab.c
		mv y.tab.c $@

%.h : %.y
		@rm -f $@
		$(YACC) -d $(YFLAGS) $<
		@chmod 444 y.tab.h
		mv y.tab.h $@
		@rm -f y.tab.c

%.h %.cc : %.dflow
		@rm -f $*.h $*.cc
		$(SHARLIT) $(SHARLIT_FLAGS) -T $<
		@sed -e 's/solver.h/$*.h/' solver.cc > $*.cc
		@mv solver.h $*.h
		@chmod 444 $*.h $*.cc
		@rm -f solver.cc

%.h %.cc : %.odflow
		@rm -f $*.h $*.cc
		$(SHARLIT) $(SHARLIT_FLAGS) $<
		@sed -e 's/solver.h/$*.h/' solver.cc >$*.cc
		@mv solver.h $*.h
		@chmod 444 $*.h $*.cc
		@rm -f solver.cc

